Subject: Cryptography Strategies don't have Singleton annotation
Description

e.g. \TYPO3\FLOW3\Security\Cryptography\Pbkdf2HashingStrategy doesn't have @FLOW3\Scope("singleton")  annotation which
leads to

#1265370540: Cannot set instance of object "TYPO3\FLOW3\Security\Cryptography\PasswordHashingStrategyInterface"
because it is of scope prototype. Only session and singleton instances can be set. 

Adding that annotation fixes the issue.

Due to the fact that Pbkdf2 isn't default anymore it's likely that it hasn't been discovered earlier, but I wonder BCrypt also hasn't that
annotation set and it seems to work?

History
#1 - 2011-12-20 15:55 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7436

#2 - 2011-12-21 11:47 - Adrian Föder

add. information:
Objects.yaml is set to

TYPO3\FLOW3\Security\Cryptography\PasswordHashingStrategyInterface:
  className: TYPO3\FLOW3\Security\Cryptography\Pbkdf2HashingStrategy

#3 - 2011-12-21 12:12 - Karsten Dambekalns

Ok, what you want to do is set the default hashing strategy. But your approach is wrong. Change the default instead in Settings.yaml:
TYPO3:
  FLOW3:
    security:
      cryptography:
        hashingStrategies:
          default: pbkdf2

The fact that the strategies miss the singleton scope annotation is something that is still a valid issue, though.

#4 - 2011-12-21 12:15 - Adrian Föder

ah, ok, thanks a lot... That's funny because my "solution" also works... but thanks; I'll change it.

Do you need further information regarding the scope annotation?

#5 - 2011-12-21 12:18 - Karsten Dambekalns
- Target version set to 1.0.2
- Affected Flow version changed from Git master to FLOW3 1.0.1

#6 - 2011-12-21 12:22 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7436

#7 - 2011-12-22 08:51 - Karsten Dambekalns
- Target version changed from 1.0.2 to 1.0.3

#8 - 2011-12-28 09:05 - Sebastian Kurfuerst

Karsten Dambekalns wrote:

Ok, what you want to do is set the default hashing strategy. But your approach is wrong. Change the default instead in Settings.yaml:
[...]
The fact that the strategies miss the singleton scope annotation is something that is still a valid issue, though.

Hey Karsten,

can you point me to the place where this is evaluated? I just grepped the full FLOW3 source for "hashingStrategies", and did not find anything!

IMHO the strategies should be allowed to be prototypes...

Greets,
Sebastian

#9 - 2012-01-02 13:56 - Christopher Hlubek

This should work without changing the scope annotation since it is prototype by intent (to allow different configurations). The strategy interface should
not be used directly as a singleton  anymore (see HashService for example). If a direct access is needed use the specific strategy (which is still
configured in Objects.yaml) or introduce a custom marker interface or factory.

#10 - 2012-01-04 13:35 - Karsten Dambekalns
- Status changed from Under Review to Closed
- % Done changed from 0 to 100

#11 - 2012-01-04 13:35 - Karsten Dambekalns

Sebastian Kurfuerst wrote:

can you point me to the place where this is evaluated? I just grepped the full FLOW3 source for "hashingStrategies", and did not find anything!

It is used in HashingService.
